import { __extends } from "tslib";
import { generalArraysEqual } from 'immutable-class';
import { ChainableExpression, Expression } from './baseExpression';
var MvFilterOnlyExpression = (function (_super) {
    __extends(MvFilterOnlyExpression, _super);
    function MvFilterOnlyExpression(parameters) {
        var _this = _super.call(this, parameters, dummyObject) || this;
        _this._ensureOp('mvFilterOnly');
        _this._checkOperandTypes('STRING');
        _this.mvArray = parameters.mvArray;
        _this.type = 'STRING';
        return _this;
    }
    MvFilterOnlyExpression.fromJS = function (parameters) {
        var value = ChainableExpression.jsToValue(parameters);
        value.mvArray = parameters.mvArray;
        return new MvFilterOnlyExpression(value);
    };
    MvFilterOnlyExpression.prototype.valueOf = function () {
        var value = _super.prototype.valueOf.call(this);
        value.mvArray = this.mvArray;
        return value;
    };
    MvFilterOnlyExpression.prototype.toJS = function () {
        var js = _super.prototype.toJS.call(this);
        js.mvArray = this.mvArray;
        return js;
    };
    MvFilterOnlyExpression.prototype.equals = function (other) {
        return _super.prototype.equals.call(this, other) && generalArraysEqual(this.mvArray, other.mvArray);
    };
    MvFilterOnlyExpression.prototype._toStringParameters = function (_indent) {
        return this.mvArray;
    };
    MvFilterOnlyExpression.prototype._getSQLChainableHelper = function (dialect, operandSQL) {
        return dialect.mvFilterOnlyExpression(operandSQL, this.mvArray);
    };
    MvFilterOnlyExpression.op = 'MvFilterOnly';
    return MvFilterOnlyExpression;
}(ChainableExpression));
export { MvFilterOnlyExpression };
Expression.register(MvFilterOnlyExpression);
